diff --git a/convert.c b/convert.c
index 1fef061..ee08876 100644
--- a/convert.c
+++ b/convert.c
@@ -1633,6 +1633,17 @@ inolog("2stime fr=%d\n", std_time.fr);
 						break;
 				else
 				{
+					if (nlen >= sizeof(calv))
+					{
+						if (dot_exist)
+							break;
+						else
+						{
+							ns->scale--;
+							result = COPY_RESULT_TRUNCATED;
+							continue;
+						}
+					}
 					if (dot_exist)
 						ns->scale++;
 					ns->precision++;
@@ -1658,15 +1669,22 @@ inolog("2stime fr=%d\n", std_time.fr);
 					ns->val[olen++] = hval;
 					hval = 0;
 					bit = 1L;
-					if (olen >= SQL_MAX_NUMERIC_LEN - 1)
+					if (olen >= SQL_MAX_NUMERIC_LEN)
 					{
-						ns->scale = sta - ns->precision;
+						if (sta < nlen)
+							result = COPY_RESULT_TRUNCATED;
 						break;
 					}
 				}
 			}
-			if (hval && olen < SQL_MAX_NUMERIC_LEN - 1)
-				ns->val[olen++] = hval;
+			if (hval)
+			{
+				if (olen >= SQL_MAX_NUMERIC_LEN)
+					result = COPY_RESULT_TRUNCATED;
+				else
+					ns->val[olen++] = hval;
+			}
+
 			}
 			break;
 #endif /* ODBCVER */
